#!/usr/bin/perl -w
#
# jumpsh - Login shell used on SSH jump box to send user to another system.
#
# Copyright (c) 2000-2008 Occam's Razor. All rights reserved.
#
# See the LICENSE file distributed with this code for restrictions on its use
# and further distribution.
# Original distribution available at <http://www.occam.com/tools/>.
#
# $Id: jumpsh.pl,v 3.1 2008/04/01 01:43:23 leonvs Exp $
#
# TODO
#

use strict;

use Getopt::Std;
use vars qw($opt_c);

# global variables
my $SCP_SUPPORT = 0;	# Allow scp through? Set to 1 to enable.
my $SERVERFILE = "/usr/local/etc/jumpsh.list";
my %serverList = ();
my $DELAY = 3;		# seconds of delay b/t tries, to slow down attackers
my $numTries = 0;
my $MAXTRIES = 3;

my $SSH = "/usr/bin/ssh";
my $SHELL = "/bin/sh";

# Handle scp connections, which come across as "-c scp ..." arguments to shell.
getopts('c:') or die "illegal argument\n";
if ($opt_c) {
	# Only valid possibility: start w/ "scp ", no semicolons.
	($opt_c !~ /^scp / || $opt_c =~ /;/) and die "illegal argument\n";

	# If scp supported, run the command.
	$SCP_SUPPORT or die "unsupported\n";
	system "$opt_c";
	exit;
}

open IN, $SERVERFILE or die "Can't open $SERVERFILE.\n";
while (<IN>) {
	/^([\w.-]+)(:([\w.-]+))?$/ or next;
	my $codename = $1;
	# If no separate hostname, set it equal to codename.
	my $hostname = $3 || $codename;
	$serverList{$codename} = $hostname;
}
close IN;

print "\nEnter a name: ";
while (<>) {
	chomp;
	my $codename = $_;
	# Strip out all but valid characters.
	$codename =~ s/[^\w.-]//;
	my $hostname = $serverList{$codename};
	if ($hostname) {
		if ($hostname eq "localhost") {
			system "$SHELL";
		} else {
			system "$SSH $hostname";
		}
		last;
	} else {
		$numTries++;
		if ($numTries < $MAXTRIES) {
			sleep $DELAY;
			print "\nNot a valid name.\nPlease try again: ";
		} else {
			last;
		}
	}
}
